
# The LearningOnline Network with CAPA
# Handler to upload files into construction space
#
# $Id: lonupload.pm,v 1.27 2004/05/14 14:53:31 www Exp $
#
# Copyright Michigan State University Board of Trustees
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/html/adm/gpl.txt
#
# http://www.lon-capa.org/
#
###

package Apache::lonupload;

use strict;
use Apache::File;
use File::Copy;
use File::Basename;
use Apache::Constants qw(:common :http :methods);
use Apache::loncacc;
use Apache::loncommon();
use Apache::Log();
use Apache::lonnet;
use HTML::Entities();
use Apache::lonlocal;

my $DEBUG=0;

sub Debug {
  
    # Marshall the parameters.
  
    my $r       = shift;
    my $log     = $r->log;
    my $message = shift;
  
    # Put out the indicated message butonly if DEBUG is false.
  
    if ($DEBUG) {
	$log->debug($message);
    }
}

sub upfile_store {
    my $r=shift;
	
    my $fname=$ENV{'form.upfile.filename'};
    $fname=~s/\W//g;
    
    chomp($ENV{'form.upfile'});
  
    my $datatoken=$ENV{'user.name'}.'_'.$ENV{'user.domain'}.
		  '_upload_'.$fname.'_'.time.'_'.$$;
    {
       my $fh=Apache::File->new('>'.$r->dir_config('lonDaemons').
                                   '/tmp/'.$datatoken.'.tmp');
       print $fh $ENV{'form.upfile'};
    }
    return $datatoken;
}


sub phaseone {
    my ($r,$fn,$uname,$udom,$mode)=@_;
    my $action = '/adm/upload';
    if ($mode eq 'testbank') {
        $action = '/adm/testbank';
    } elsif ($mode eq 'imsimport') {
        $action = '/adm/imsimport';
    }
    $ENV{'form.upfile.filename'}=~s/\\/\//g;
    $ENV{'form.upfile.filename'}=~s/^.*\/([^\/]+)$/$1/;
    if ($ENV{'form.upfile.filename'}) {
	$fn=~s/\/[^\/]+$//;
	$fn=~s/([^\/])$/$1\//;
	$fn.=$ENV{'form.upfile.filename'};
	$fn=~s/^\///;
	$fn=~s/(\/)+/\//g;

#    Fn is the full path to the destination filename.
#    

	&Debug($r, "Filename for upload: $fn");
	if (($fn) && ($fn!~/\/$/)) {
	    $r->print('<form action="'.$action.'" method="post">'.
		      '<input type="hidden" name="phase" value="two" />'.
		      '<input type="hidden" name="datatoken" value="'.
		      &upfile_store.'" />'.
		      '<input type="hidden" name="uploaduname" value="'.$uname.
		      '" />'.&mt('Store uploaded file as ').
                      "<tt>/priv/$uname/</tt>".
                      '<input type="text" size="50" name="filename" value="'.$fn.
                      '" /><br />');
            $r->print('<br />'.&mt('Please indicate the type of file you are uploading. The possible types of file are as follows:').'
<ul>
 <li><b>'.&mt('Regular file:').'</b>'.&mt(' A file that requires no special handling during upload. The "Regular file" designation applies to html files, image files etc., as well as to zip, tar or gzip files that you wish to decompress after upload. In the case of a zip/tar/gz file etc., once the file has been uploaded, a "Decompress" link will automatically be displayed adjacent to the name of the file in the display of construction space directory contents. You will be able to decompress this file by clicking the link.').'</li>     
 <li><b>'.&mt('Testbank file:').'</b>'.&mt(' a testbank file containing plain text (ascii) questions and answers, which you plan to convert to LON-CAPA problems. The following question types can be converted: 1 of N multiple choice questions, individual True/False questions, groups of True/False questions, Fill-in-the-blank questions, Ranking questions, and Essay/short answer questions. Specific information about the format of the questions, foils, and correct answers is available ').'<a href="javascript:testbankWin()">'.&mt('here').'</a>,'.&mt(' and is also included in the pages displayed during step-by-step conversion of the testbank. The original testbank file can be removed from your construction space later, once the testbank questions have been converted.').'</li>
<li><b>'.&mt('IMS package').':</b>'.&mt(' a file containing course content from another Course Management System (e.g., Blackboard or ANGEL) packaged according to the IMS 1.1 specification.  The original IMS package file can be removed from your construction space later, once the package has been decompressed and the files converted to LON-CAPA sequence, page, problem, or bulletin board files, or stored as html, image or movie files etc., as appropriate.').'</li>
</ul>
<br />'.&mt('Choose file type:').'
<select name="filetype">
 <option value="standard" selected>'.&mt('Regular file').'
 <option value="testbank">'.&mt('Testbank file').'
 <option value="imsimport">'.&mt('IMS package').'
</select>
<br />
<br />
');
            $r->print('<input type="button" value="'.&mt('Store').'" onClick="javascript:verifyForm()"/></form>');
	    # Check for bad extension and warn user
	    if ($fn=~/\.(\w+)$/ && 
		(&Apache::loncommon::fileembstyle($1) eq 'hdn')) {
		$r->print('<font color="red">'.&mt('The extension on this file,').
			  ' "'.$1.'"'.&mt(', is reserved internally by LON-CAPA.').
			  ' <br />'.&mt('Please change the extension.').'</font>');
	    } elsif($fn=~/\.(\w+)$/ && 
		    !defined(&Apache::loncommon::fileembstyle($1))) {
		$r->print('<font color="red">'.&mt('The extension on this file,').
			  ' "'.$1.'"'.&mt(', is not recognized by LON-CAPA.').
			  ' <br />'.&mt('Please change the extension.').
			  '</font>');
	    }
	} else {
	    $r->print('<font color="red">'.&mt('Illegal filename.').'</font>');
	}
    } else {
	$r->print('<font color="red">'.&mt('No upload file specified.').'</font>');
    }
}

sub phasetwo {
    my ($r,$tfn,$uname,$udom,$mode)=@_;
    my $action = '/adm/upload';
    my $returnflag = '';
    if ($mode eq 'testbank') {
        $action = '/adm/testbank';
    } elsif ($mode eq 'imsimport') {
        $action = '/adm/imsimport';
    }
    my $fn='/priv/'.$uname.'/'.$tfn;
    $fn=~s/\/+/\//g;
    &Debug($r, "Filename is ".$tfn);
    if ($tfn) {
	&Debug($r, "Filename for tfn = ".$tfn);
	my $target='/home/'.$uname.'/public_html'.$tfn;
	&Debug($r, "target -> ".$target);
#     target is the full filesystem path of the destination file.
	my $base = &File::Basename::basename($fn);
	my $path = &File::Basename::dirname($fn);
	$base    = &HTML::Entities::encode($base,'<>&"');
	my $url  = $path."/".$base; 
	&Debug($r, "URL is now ".$url);
	my $datatoken=$ENV{'form.datatoken'};
	if (($fn) && ($datatoken)) {
	    if ((-e $target) && ($ENV{'form.override'} ne 'Yes')) {
		$r->print('<form action="'.$action.'" method="post">'.
			  &mt('File').' <tt>'.$fn.'</tt> '.
			  &mt('exists. Overwrite?').' '.
			  '<input type="hidden" name="phase" value="two" />'.
			  '<input type="hidden" name="filename" value="'."$url".'" />'.
			  '<input type="hidden" name="datatoken" value="'.$datatoken.'" />'.
			  '<input type="submit" name="override" value="'.&mt('Yes').'" /></form>');
	    } else {
		my $source=$r->dir_config('lonDaemons').'/tmp/'.$datatoken.'.tmp';
		my $dirpath=$path.'/';
		$dirpath=~s/\/+/\//g;
		# Check for bad extension and disallow upload
		if ($fn=~/\.(\w+)$/ && 
		    (&Apache::loncommon::fileembstyle($1) eq 'hdn')) {
		    $r->print(&mt('File').' <tt>'.$fn.'</tt> '.
			      &mt('could not be copied.').'<br />'.
			      '<font color="red">'.
			      &mt('The extension on this file is reserved internally by LON-CAPA.').
			      '</font>');
		    $r->print('<br /><font size=+2><a href="'.$dirpath.'">'.
			      &mt('Back to Directory').'</a></font>');
		} elsif ($fn=~/\.(\w+)$/ && 
			 !defined(&Apache::loncommon::fileembstyle($1))) {
		    $r->print(&mt('File').' <tt>'.$fn.'</tt> '.
			      &mt('could not be copied.').'<br />'.
			      '<font color="red">'.
			      &mt('The extension on this file is not recognized by LON-CAPA.').
			      '</font>');
		    $r->print('<br /><font size="+2"><a href="'.$dirpath.'">'.
			      &mt('Back to Directory').'</a></font>');
		} elsif (-d $target) {
		    $r->print('File <tt>'.$fn.'</tt> could not be copied.<br />'.
			      '<font color="red">'.
			      &mt('The target is an existing directory.').
			      '</font><br />');
		    $r->print('<font size="+2"><a href="'.$dirpath.'">'.
			      &mt('Back to Directory').'</a></font>');
		} elsif (copy($source,$target)) {
		    chmod(0660, $target); # Set permissions to rw-rw---.
                    if ($mode eq 'testbank' || $mode eq 'imsimport') {
                        $r->print(&mt("Your file - $fn - was uploaded successfully")."<br /><br />");
                        $returnflag = 'ok';
                    } else {
                        $r->print(&mt('File copied.'));
		        $r->print('<br /><font size="+2"><a href="'.$url.'">'.
			      &mt('View file').'</a></font>');
		        $r->print('<br /><font size="+2"><a href="'.$dirpath.'">'.
			      &mt('Back to Directory').'</a></font><br />');
                    }
		} else {
		    $r->print('Failed to copy: '.$!);
		    $r->print('<br /><font size="+2"><a href="'.$path.'">'.
			      &mt('Back to Directory').'</a></font>');
		}
	    }
	} else {
	    $r->print('<font size="+1" color="red">'.
		      &mt('Please use browser "Back" button and pick a filename').
		      '</font><br />');
	}
    } else {
	$r->print('<font size=+1 color=red>'.
		  &mt('Please use browser "Back" button and pick a filename').
		  '</font><br />>');
    }
    return $returnflag;
}

# ---------------------------------------------------------------- Main Handler
sub handler {

    my $r=shift;

    my $uname;
    my $udom;
    my $javascript = '';
#
# phase two: re-attach user
#
    if ($ENV{'form.uploaduname'}) {
	$ENV{'form.filename'}='/priv/'.$ENV{'form.uploaduname'}.'/'.
	    $ENV{'form.filename'};
    }

    unless ($ENV{'form.phase'} eq 'two') {
        $javascript = qq|
function verifyForm() {
    var mode = document.forms[0].filetype.options[document.forms[0].filetype.selectedIndex].value
    if (mode == "testbank") {
        document.forms[0].action = "/adm/testbank";
    }
    if (mode == "imsimport") {
        document.forms[0].action = "/adm/imsimport";
    }
    if (mode == "standard") {
        document.forms[0].action = "/adm/upload";
    }
    document.forms[0].submit();
}

function testbankWin() {
  newWindow = window.open("","testbankinfo","HEIGHT=400,WIDTH=750,scrollbars=yes")
  newWindow.document.open()
  newWindow.document.write("<html><head><title>'Importing a Testbank file into LON-CAPA</title><meta http-equiv='pragma' content='no-cache'>\\n")
  newWindow.document.write("</head><body bgcolor='#CCFFDD' topmargin='0' leftmargin='0' marginheight='0'marginwidth='0' rightmargin='0'>\\n")
  newWindow.document.write("<img border='0' src='/adm/lonInterFace/author.jpg' alt='[Author Header]'>\\n")
  newWindow.document.write("<table border='0' cellspacing='0' cellpadding='0' width='95%' bgcolor='#CCFFDD'>\\n")
  newWindow.document.write("<tr><td width='2'>&nbsp;</td><td width='3'>&nbsp;</td>\\n")
  newWindow.document.write("<td><font face='arial,helvetica,sans-serif'><h3>Importing Testbank questions into LON-CAPA</h3>")
  newWindow.document.write("<font face='arial,helvetica,sans-serif'><br />Four requirements must be met to ensure that you will succeed in building LON-CAPA problem files using your plain text file containing testbank questions.")
  newWindow.document.write("<ol><li>The questions and answers you upload must be in plain text format.  Any header lines should occur before the text containing the questions and answers.</li>")
  newWindow.document.write("<li>All questions must occur before any of the answers.  Each question should be numbered sequentially using a number followed immediately by a space, a period, or enclosed in parentheses, i.e., 1 , 1., (1), 1), or (1 .</li>")
   newWindow.document.write("<li>One or more correct answers should be provided for all questions (although blank answers may be provided for <i>essay</i> questions).  Answers should be numbered sequentially, using the same scheme as used for the questions, and must occur after all the questions.")
    newWindow.document.write("<li><i>Multiple choice</i> and <i>multiple answer correct</i> questions should consist of (i) the question number followed by (ii) a question stem beginning on the same line and (iii) two or more foils, with each foil beginning on a new line and prefixed by a unique letter, or Roman numeral, listed in alphabetic or numeric order, beginning at a (alphabetic) or i (Roman numeral), followed by a period, or enclosed in parentheses, i.e., a., (a), i., or (i) .</li>")
     newWindow.document.write("<li>If <i>fill-in-the-blank</i> or <i>multiple answer</i> questions have more than one correct answer, each answer should appear in a comma-, tab-, space-, or new line-delimited list. </li></ol>")
  newWindow.document.write("</td></tr>\\n")
  newWindow.document.write("</table></body></html>")
  newWindow.document.close()
  newWindow.focus()
}
|;
    }
    ($uname,$udom)=
	&Apache::loncacc::constructaccess($ENV{'form.filename'},
					  $r->dir_config('lonDefDomain'));
    unless (($uname) && ($udom)) {
	$r->log_reason($uname.' at '.$udom.
		       ' trying to publish file '.$ENV{'form.filename'}.
		       ' - not authorized', 
		       $r->filename); 
	return HTTP_NOT_ACCEPTABLE;
    }
    
    my $fn;
    if ($ENV{'form.filename'}) {
	$fn=$ENV{'form.filename'};
	$fn=~s/^http\:\/\/[^\/]+\///;
	$fn=~s/^\///;
	$fn=~s/(\~|priv\/)(\w+)//;
	$fn=~s/\/+/\//g;
    } else {
	$r->log_reason($ENV{'user.name'}.' at '.$ENV{'user.domain'}.
		       ' unspecified filename for upload', $r->filename); 
	return HTTP_NOT_FOUND;
    }

# ----------------------------------------------------------- Start page output


    &Apache::loncommon::content_type($r,'text/html');
    $r->send_http_header;

    $r->print("<html><head><title>LON-CAPA Construction Space</title><script type=\"text/javascript\">\n//<!--\n$javascript\n// --></script>\n</head>");

    $r->print(&Apache::loncommon::bodytag('Upload file to Construction Space'));
  
    if (($uname ne $ENV{'user.name'}) || ($udom ne $ENV{'user.domain'})) {
	$r->print('<h3><font color=red>'.&mt('Co-Author').': '.$uname.
		  &mt(' at ').$udom.'</font></h3>');
    }

    if ($ENV{'form.phase'} eq 'two') {
	&phasetwo($r,$fn,$uname,$udom);
    } else {
	&phaseone($r,$fn,$uname,$udom);
    }

    $r->print('</body></html>');
    return OK;  
}

1;
__END__

=head1 NAME

Apache::lonupload - upload files into construction space

=head1 SYNOPSIS

Invoked by /etc/httpd/conf/srm.conf:

 <Location /adm/upload>
 PerlAccessHandler       Apache::lonacc
 SetHandler perl-script
 PerlHandler Apache::lonupload
 ErrorDocument     403 /adm/login
 ErrorDocument     404 /adm/notfound.html
 ErrorDocument     406 /adm/unauthorized.html
 ErrorDocument	  500 /adm/errorhandler
 </Location>

=head1 INTRODUCTION

This module uploads a file sitting on a client computer into 
library server construction space.

This is part of the LearningOnline Network with CAPA project
described at http://www.lon-capa.org.

=head1 HANDLER SUBROUTINE

This routine is called by Apache and mod_perl.

=over 4

=item *

Initialize variables

=item *

Start page output

=item *

output relevant interface phase (phaseone or phasetwo)

=item *

(phase one is to specify upload file; phase two is to handle conditions
subsequent to specification--like overwriting an existing file)

=back

=head1 OTHER SUBROUTINES

=over 4

=item *

phaseone() : Interface for specifying file to upload.

=item *

phasetwo() : Interface for handling post-conditions about uploading (such
as overwriting an existing file).

=item *

upfile_store() : Store contents of uploaded file into temporary space.  Invoked
by phaseone subroutine.

=back

=cut
